# ==================================================================
# Plugins::GForum::Who_Online - Auto Generated Program Module
#
#   Plugins::GForum::Who_Online
#   Author  : Paul Wilson
#   Version : 0.0.1
#   Updated : Mon Dec  3 01:36:15 2001
#
# ==================================================================
#

package Plugins::GForum::Who_Online;
# ==================================================================

use strict;
use GT::Base;
use GT::SQL::Condition;
use GT::Date;
use GForum::Plugins;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/:user $USER $IN $DB $CFG/;

# Inhert from base class for debug and error methods
@Plugins::GForum::Who_Online::ISA = qw(GT::Base);

# Your code begins here! Good Luck!

sub who {

    shift;
    my ($do, $func) = @_;
    my $page = $func->{page};
    $DB->table('Online')->delete(GT::SQL::Condition->new(online_time => '<' => (time - $CFG->{online_timeout} * 60)));

    my $cond = new GT::SQL::Condition;
    $cond->add(user_id_fk => '!=' => '0');
    $cond->add(user_invisible => '=' => 0) unless $USER and $USER->{user_status} == ADMINISTRATOR;
    my $ou = $DB->table('Online' => 'User');
    $ou->select_options("ORDER BY online_time DESC");
    my $sth = $ou->select($cond, ['user_username']);

    my $users = [];
    my $vars = GForum::Plugins->get_plugin_user_cfg('Who_Online');

    while (my $rec = $sth->fetchrow_hashref) {
        normalize($rec);
        push @$users, $rec->{user_username};
    }
    
    return join $vars->{Delimeter}, @$users;

}

sub normalize {
    my $rec = shift;
    GT::Plugins->dispatch($CFG->{admin_root_path} . '/Plugins/GForum', "online_normalize", sub { return _plg_normalize(@_) }, $rec);
}

sub _plg_normalize {
    my $rec = shift;
    require GForum::User;
    GForum::User::normalize($rec) if $rec->{user_id_fk};
    $rec->{online_date} = GT::Date::date_get($rec->{online_time}, $CFG->{date_user_format});
    $rec;
}

# Always end with a 1.
1;
